<?PHP
/************************** admin/index.php ********************** 2009-09-30 AF
* Administration interface for AForum. This interface is used for:
* - installing forum software
* - creating or deleting messageboards
* - assigning moderator passwords

GNU General Public License www.gnu.org/copyleft/gpl.html

*******************************************************************************/

$Forum_Version = '1.44';     // define version number

/******************************* Subfunctions *********************************/

// Que message for output
function QueMessage($m){
  GLOBAL $message;
  if(!empty($message)) {
    $message .="<p>\n";}
  $message .= $m;}

// Output feedback message
function output_feedback($text = ''){
  GLOBAL $message;
  if (!$text) {
    $text = $message; $message = '';}
  if ($text) {
    echo "<center><div class=\"message\">\n$text</div></center>\n";}}

// add initial slash and remove trailing slash from directory name
function CheckDirSlash($dir) {
  $dir=trim($dir);
  if (empty($dir)) return '';
  if(substr($dir, 0, 1)!="/") {$dir='/'.$dir;}
  if(substr($dir, -1)=="/") {$dir=substr($dir, 0, -1);}
  return $dir;}

// remove undesired characters from login name or password
function CleanWord($word) {
  $word = strtolower(eregi_replace('[^a-z0-9_\-]', '_', $word));
  return $word;}

// set a variable to a value if not allready set
function InitVar($var, $value) {
  GLOBAL $$var;
  if (!isset($$var)) {
    $$var = $value;}}

// counts the number of records in a table
function number_of_records($table_name) {
  GLOBAL $qq, $DB;
  $sSQL = "Select COUNT(*) as count from $table_name";
  if ($qq->error()) return 0;
  $qq->query($DB, $sSQL);
  $rec=$qq->getrow();
  return $rec['count'];}

// tells whether a table exists
function table_exists($table_name) {
  // Isn't there a better way of doing this?
  GLOBAL $qq, $DB;
  $sSQL = "show columns from $table_name";
  $qq->query($DB, $sSQL);
  return $qq->error() ? 0 : 1;}

// Make backup copy of a file
function BackupCopyFile($filename) {
  if (file_exists($filename)) {
    copy($filename, $filename.'.bak');
    if (function_exists('chmod')) {
      chmod($filename.'.bak',0600);}}}

// Write administration data file
function WriteAdminData() {
  GLOBAL $AdminLogin, $AdminPassword, $CryptAdminPassword,
  $BaseAbsDir, $CommonAbsDir, $MainDataFile, $AdminDataFile, $MainFuncFile,
  $ext, $CryptSalt, $moderators, $user;

  $filename=basename($AdminDataFile);
  if ($AdminPassword) {
    $CryptAdminPassword = crypt($AdminPassword,$CryptSalt);}
  $data = "<?PHP\n// $filename      Created  ".date('Y-m-d')."\n"
  ."// Variables for forum administration.\n"
  ."// DO NOT EDIT THIS FILE.  USE THE ADMIN INTERFACE\n\n"
  ."// files and paths\n"
  ."\$BaseAbsDir='$BaseAbsDir';\n"
  ."\$CommonAbsDir='$CommonAbsDir';\n"
  ."\$MainDataFile='$MainDataFile';\n"
  ."\$AdminDataFile='$AdminDataFile';\n"
  ."\$MainFuncFile='$MainFuncFile';\n"
  ."\$ext='$ext';\n"
  ."\$AdminLogin='$AdminLogin';\n"
  ."\$CryptAdminPassword='$CryptAdminPassword';\n";
  if (!empty($moderators)) {
    reset($moderators);
    while (list($key,$value) = each($moderators)) {
      $n = $moderators[$key]['name'];
      $p = $moderators[$key]['pass'];
      $a = $moderators[$key]['access'];
      $data .=
      "\$moderators['$key']['name'] = '$n';\n" .
      "\$moderators['$key']['pass'] = '$p';\n" .
      "\$moderators['$key']['access'] = '$a';\n";}}
  $data .= "\n?>";
  BackupCopyFile($AdminDataFile);
  $fp = fopen($AdminDataFile, "w");
  $success = $fp && fputs($fp, $data) && fclose($fp);
  if ($success) {
    QueMessage("Administration data file $filename updated successfully.");}
  else {
    // can't write. make error message
    if (file_exists($AdminDataFile)) {$a = 'write to';} else {$a = 'create';}
    QueMessage("Can't $a file $AdminDataFile as user $user. Please provide write access to directory $CommonAbsDir.");}
  return $success;}

// write main data file
function WriteMainData() {
  GLOBAL $BaseAbsDir, $CommonAbsDir, $MainDataFile, $AdminDataFile,
  $ImgVirtDir, $BoardsListName, $BoardsListPage, $ext, $dbName,
  $dbUser, $dbPass, $dbServer, $list_page, $search_page, $read_page,
  $post_page, $faq_page, $UseCookies, $ActiveBoards, $ServerName, $Forum_Version;
  $filename=basename($MainDataFile);
  $data = "<?PHP\n// $filename      Created  ".date('Y-m-d')."\n"
  ."// Variables shared by all messageboards.\n"
  ."// DO NOT EDIT THIS FILE.  USE THE ADMIN INTERFACE\n\n"
  ."\$ForumVersion='$Forum_Version';\n"
  ."// database variables\n"
  ."\$dbName='$dbName';\n"
  ."\$dbUser='$dbUser';\n"
  ."\$dbPass='$dbPass';\n"
  ."\$dbServer='$dbServer';\n"
  ."\$BoardsListName='$BoardsListName';\n"
  ."\$UseCookies='$UseCookies';\n"
  ."// files and paths\n"
  ."\$ServerName='$ServerName';\n"
  ."\$BaseAbsDir='$BaseAbsDir';\n"
  ."\$CommonAbsDir='$CommonAbsDir';\n"
  ."\$MainDataFile='$MainDataFile';\n"
  ."\$AdminDataFile='$AdminDataFile';\n"
  ."\$ImgVirtDir='$ImgVirtDir';\n"
  ."\$ActiveBoards='$ActiveBoards';\n"
  ."\$BoardsListPage='$BoardsListPage';\n"
  ."\$list_page='$list_page';\n"
  ."\$search_page='$search_page';\n"
  ."\$read_page='$read_page';\n"
  ."\$post_page='$post_page';\n"
  ."\$faq_page='$faq_page';\n"
  ."\$ext='$ext';\n\n"
  ."?>";
  BackupCopyFile ($MainDataFile);
  $fp = fopen($MainDataFile, "w");
  $success = $fp && fputs($fp, $data) && fclose($fp);
  if ($success) {
    QueMessage("Main data file $filename updated successfully.");}
  else {
    QueMessage("Error: Can't write main data file $MainDataFile.<br>Please check the path and provide write access to this file or directory.");}
  return $success;}

// set all unset variables to default values
function SetDefaultVars() {
  GLOBAL $BaseVirtDir, $BaseAbsDir, $CommonAbsDir, $MainDataFile, $MainFuncFile,
    $AdminDataFile, $ImgVirtDir, $BoardsListPage, $BoardsListName, $ServerName,
    $ext, $UseCookies, $list_page, $search_page, $read_page, $post_page,
    $faq_page, $moderators,
    $AdminLogin, $AdminPassword, $CryptAdminPassword;

  // get virtual path:
  $virtual_self_name = $_SERVER['PHP_SELF'];

  // get absolute path:
  if (empty($_SERVER['PATH_TRANSLATED'])) {
    $absolute_self_name = $_SERVER['DOCUMENT_ROOT'] . $virtual_self_name;}
  else {
    $absolute_self_name = $_SERVER['PATH_TRANSLATED'];}

  InitVar('ServerName', $_SERVER['SERVER_NAME']);
  InitVar('BaseVirtDir', dirname(dirname($virtual_self_name)));
  InitVar('BaseAbsDir', dirname(dirname($absolute_self_name)));

  InitVar('CommonAbsDir', $BaseAbsDir.'/common');
  InitVar('MainDataFile', "$CommonAbsDir/svars.$ext");
  InitVar('AdminDataFile', "$CommonAbsDir/avars.$ext");
  InitVar('MainFuncFile', "$CommonAbsDir/func.phpi");
  InitVar('ImgVirtDir', $BaseVirtDir.'/images');
  InitVar('BoardsListPage', $BaseVirtDir);
  InitVar('BoardsListName', 'BoardsList');
  InitVar('UseCookies', 1);
  InitVar('ActiveBoards', 0);
  InitVar('list_page', 'index');
  InitVar('search_page', 'search');
  InitVar('read_page', 'read');
  InitVar('post_page', 'post');
  InitVar('faq_page', 'faq');
  InitVar('down', 0);
  InitVar('AdminLogin', 'administrator');
  if (!empty($AdminPassword)) {
    InitVar('CryptAdminPassword', crypt($AdminPassword,$CryptSalt));
    if (empty($moderators)) {
      $moderators[$AdminLogin]['name'] = 'Administrator';
      $moderators[$AdminLogin]['pass'] = $CryptAdminPassword;
      $moderators[$AdminLogin]['access'] = 'all';}}}


/******************************* Initializations ******************************/

foreach ($_REQUEST as $key => $val) unset($$key); // remove global variables if register_globals is on
if (isset($_REQUEST['action'])) $aaction = $_REQUEST['action']; else $aaction = '';

$adminaccess = '';
$myname = $_SERVER['PHP_SELF'];
$DOCUMENT_ROOT = $_SERVER['DOCUMENT_ROOT'];

$ext = ereg_replace('.*\.', '', basename($myname));  // default file extension (.php)
$aheader = "include/ahead.phpi";
$afooter = "include/afoot.phpi";

$CryptSalt = 'jV';
$message = '';
SetDefaultVars();

$user = 'unknown';
if (function_exists('posix_getpwuid')) {
  $a = posix_getpwuid(posix_geteuid());
  $user = $a['name'];}

/******************************* Get data files *******************************/

$AdminDataFile = "../common/avars.$ext";

if (file_exists($AdminDataFile)) {
  include $AdminDataFile;}
else {
  // File with admin password etc. not found.
  SetDefaultVars();
  if (empty($aaction)) {
    QueMessage("First time setup. Variables set to default.");
    $aaction = 'pass';}
  $success = WriteAdminData();
  if ($success) {
    if (function_exists(chmod)) {
      chmod($AdminDataFile,0600); // this will prevent read access to anybody else
      }}
  else {
    // cannot create data file. Error message has already been written
    QueMessage("Data not stored.");}}

if (empty($CryptAdminPassword)) {
  $adminaccess = 1;
  if (empty($_POST['newPassword'])) {
    QueMessage("Administrator password not defined. Please set password.");
    $aaction = 'pass'; }}

if (file_exists($MainDataFile)) {
  include $MainFuncFile;}
else {
  // File with main variables not found.
  if ($aaction != 'pass') {
    $aaction = 'database';
    SetDefaultVars();
    $success = WriteMainData();
    if ($success) {
      if (function_exists(chmod)) {
        chmod($MainDataFile,0600); // this will prevent read access to anybody else
        }
      include $MainFuncFile;}
    else {
      // cannot create data file. Error message has already been written
      QueMessage("Data not stored.");}}}

/******************************* Log in ***************************************/

include "include/alogin.phpi";
if (!$adminaccess) login();

if ($aaction == 'logout') {
  logout();
  header("Location: $BoardsListPage");
  exit;}
if (!$adminaccess) exit;

if (function_exists('OpenDatabase')) $qq = OpenDatabase();

/******************************* Determine action *****************************/

// allowed subpages:
$admpages=',adminmenu,selectmod,editmod,editmod2,deletemod,database,database2,'
 . ',files,files2,selectmb,editmb,editmb2,confirmdeletemb,deletemb,backup,backup2,backup3,'
 . ',backup4,restore,restore2,restore3,restore4,restore5,pass,pass2,';

if(empty($aaction)) $aaction = 'adminmenu';   // default action

if (is_array($_POST)) { // loop through HTTP POST parameters
  reset($_POST);
  while (list($key,$val) = each($_POST)) {
    $$key = $val;                                  // create variable from HTTP POST parameter
    if (ereg('action_([[:alnum:]]+)', $key, $a)) { // extract action from name of submit key
      $aaction = $a[1];}}}

if ($aaction == 'cancel') {
  QueMessage('Action cancelled');
  $aaction = 'adminmenu';}

if ($aaction) {
  if(strstr($admpages,",$aaction,")) {
    $page = $aaction;}
  else {
    $page = '';
    QueMessage("Unknown action $aaction");}}

if(empty($DB->connect_id) && !strstr($aaction,'database') && $aaction != 'pass'){
  QueMessage("No connection to database. Please check
  <a href=\"$myname?action=database\">database settings</a>.");}

/******************************* Show selected page ***************************/

if(strstr($page,'editmb')){
  include "include/boardoptions.phpi";}

if ($page != 'pass2' && $page != 'database2') {
  include $aheader;
  output_feedback();}

if($page){
  include "include/$page.phpi";}

if (!defined('_AHEADER_')) include $aheader;

output_feedback();

if($aaction == 'adminmenu'){
  include "include/$aaction.phpi";}

include $afooter;


?>
